---
title: <feColorMatrix>
slug: Web/SVG/Element/feColorMatrix
tags:
  - Element
  - SVG
  - SVG Filter
---
<div>{{SVGRef}}</div>

<p>The <strong><code>&lt;feColorMatrix&gt;</code></strong> SVG filter element changes colors based on a transformation matrix. Every pixel's color value <code>[R,G,B,A]</code> is <a class="external" href="https://en.wikipedia.org/wiki/Matrix_multiplication">matrix multiplied</a> by a 5 by 5 color matrix to create new color <code>[R<em>'</em>,G<em>'</em>,B<em>'</em>,A<em>'</em>]</code>.</p>

<div class="notecard note">
<p>The prime symbol <em><code><strong>'</strong></code></em> is used in mathematics indicate the result of a transformation.</p>
</div>

<pre class="notranslate">| R<em>'</em> |     | r<sub>1</sub> r<sub>2</sub> r<sub>3</sub> r<sub>4</sub> r<sub>5</sub> |   | R |
| G<em>'</em> |     | g<sub>1</sub> g<sub>2</sub> g<sub>3</sub> g<sub>4</sub> g<sub>5</sub> |   | G |
| B<em>'</em> |  =  | b<sub>1</sub> b<sub>2</sub> b<sub>3</sub> b<sub>4</sub> b<sub>5</sub> | * | B |
| A<em>'</em> |     | a<sub>1</sub> a<sub>2</sub> a<sub>3</sub> a<sub>4</sub> a<sub>5</sub> |   | A |
| 1  |     | 0  0  0  0  1 |   | 1 |</pre>

<p>In simplified terms, below is how each color channel in the new pixel is calculated. The last row is ignored because its values are constant.</p>

<pre class="notranslate">R<em>'</em> = r<sub>1</sub>*R + r<sub>2</sub>*G + r<sub>3</sub>*B + r<sub>4</sub>*A + r<sub>5</sub>
G<em>'</em> = g<sub>1</sub>*R + g<sub>2</sub>*G + g<sub>3</sub>*B + g<sub>4</sub>*A + g<sub>5</sub>
B<em>'</em> = b<sub>1</sub>*R + b<sub>2</sub>*G + b<sub>3</sub>*B + b<sub>4</sub>*A + b<sub>5</sub>
A<em>'</em> = a<sub>1</sub>*R + a<sub>2</sub>*G + a<sub>3</sub>*B + a<sub>4</sub>*A + a<sub>5</sub>
</pre>

<p>Take the amount of red in the new pixel, or <code>R<em>'</em></code>:</p>

<p>It is the sum of:</p>

<ul>
 <li><code>r<sub>1</sub></code> times the old pixel's red <code>R</code>,</li>
 <li><code>r<sub>2</sub></code> times the old pixel's green <code>G</code>,</li>
 <li><code>r<sub>3</sub></code> times of the old pixel's blue <code>B</code>,</li>
 <li><code>r<sub>4</sub></code> times the old pixel's alpha <code>A</code>,</li>
 <li>plus a shift <code>r<sub>5</sub></code>.</li>
</ul>

<p>These specified amounts can be any real number, though the final <strong>R'</strong> will be clamped between 0 and 1. The same goes for <strong>G'</strong>, <strong>B'</strong>, and <strong>A'</strong>.</p>

<pre class="notranslate">R'      =      r1 * R      +        r2 * G      +       r3 * B      +       r4 * A       +       r5
New red = [ r1 * old red ] + [ r2 * old green ] + [ r3 * old Blue ] + [ r4 * old Alpha ] + [ shift of r5 ]</pre>

<p>If, say, we want to make a completely black image redder, we can make the <code>r<sub>5</sub></code> a positive real number <em>x</em>, boosting the redness on every pixel of the new image by <em>x</em>.</p>

<p>An <strong>identity matrix</strong> looks like this:</p>

<pre class="notranslate">     R G B A W
R' | 1 0 0 0 0 |
G' | 0 1 0 0 0 |
B' | 0 0 1 0 0 |
A' | 0 0 0 1 0 |
</pre>

<p>In it, every new value is exactly 1 times its old value, with nothing else added. It is recommended to start manipulating the matrix from here.</p>

<h2 id="Usage_context">Usage context</h2>

<p>{{svginfo}}</p>

<h2 id="Attributes">Attributes</h2>

<h3 id="Global_attributes">Global attributes</h3>

<ul>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Core_attributes">Core attributes</a></li>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Presentation_attributes">Presentation attributes</a></li>
 <li><a href="/en-US/docs/Web/SVG/Attribute#Filter_primitive_attributes">Filter primitive attributes</a></li>
 <li>{{SVGAttr("class")}}</li>
 <li>{{SVGAttr("style")}}</li>
</ul>

<h3 id="Specific_attributes">Specific attributes</h3>

<ul>
 <li>{{SVGAttr("in")}}</li>
 <li>{{SVGAttr("type")}}</li>
 <li>{{SVGAttr("values")}}</li>
</ul>

<h2 id="DOM_Interface">DOM Interface</h2>

<p>This element implements the {{domxref("SVGFEColorMatrixElement")}} interface.</p>

<h2 id="Example">Example</h2>

<h3 id="SVG">SVG</h3>

<pre class="brush: html; highlight[19-24,31-33,40-42,49-50] notranslate">&lt;svg width="100%" height="100%" viewBox="0 0 150 500"
    preserveAspectRatio="xMidYMid meet"
    xmlns="http://www.w3.org/2000/svg"
    xmlns:xlink="http://www.w3.org/1999/xlink"&gt;

  &lt;!-- ref --&gt;
  &lt;defs&gt;
    &lt;g id="circles"&gt;
      &lt;circle cx="30" cy="30" r="20" fill="blue" fill-opacity="0.5" /&gt;
      &lt;circle cx="20" cy="50" r="20" fill="green" fill-opacity="0.5" /&gt;
      &lt;circle cx="40" cy="50" r="20" fill="red" fill-opacity="0.5" /&gt;
    &lt;/g&gt;
  &lt;/defs&gt;
  &lt;use href="#circles" /&gt;
  &lt;text x="70" y="50"&gt;Reference&lt;/text&gt;

  &lt;!-- identity matrix --&gt;
  &lt;filter id="colorMeTheSame"&gt;
    &lt;feColorMatrix in="SourceGraphic"
        type="matrix"
        values="1 0 0 0 0
                0 1 0 0 0
                0 0 1 0 0
                0 0 0 1 0" /&gt;
   &lt;/filter&gt;
  &lt;use href="#circles" transform="translate(0 70)" filter="url(#colorMeTheSame)" /&gt;
  &lt;text x="70" y="120"&gt;Identity matrix&lt;/text&gt;

  &lt;!-- Combine RGB into green matrix --&gt;
  &lt;filter id="colorMeGreen"&gt;
    &lt;feColorMatrix in="SourceGraphic"
        type="matrix"
        values="0 0 0 0 0
                1 1 1 1 0
                0 0 0 0 0
                0 0 0 1 0" /&gt;
  &lt;/filter&gt;
  &lt;use href="#circles" transform="translate(0 140)" filter="url(#colorMeGreen)" /&gt;
  &lt;text x="70" y="190"&gt;rgbToGreen&lt;/text&gt;

  &lt;!-- saturate --&gt;
  &lt;filter id="colorMeSaturate"&gt;
    &lt;feColorMatrix in="SourceGraphic"
        type="saturate"
        values="0.2" /&gt;
  &lt;/filter&gt;
  &lt;use href="#circles" transform="translate(0 210)" filter="url(#colorMeSaturate)" /&gt;
  &lt;text x="70" y="260"&gt;saturate&lt;/text&gt;

  &lt;!-- hueRotate --&gt;
  &lt;filter id="colorMeHueRotate"&gt;
    &lt;feColorMatrix in="SourceGraphic"
        type="hueRotate"
        values="180" /&gt;
  &lt;/filter&gt;
  &lt;use href="#circles" transform="translate(0 280)" filter="url(#colorMeHueRotate)" /&gt;
  &lt;text x="70" y="330"&gt;hueRotate&lt;/text&gt;

  &lt;!-- luminanceToAlpha --&gt;
  &lt;filter id="colorMeLTA"&gt;
    &lt;feColorMatrix in="SourceGraphic"
        type="luminanceToAlpha" /&gt;
  &lt;/filter&gt;
  &lt;use href="#circles" transform="translate(0 350)" filter="url(#colorMeLTA)" /&gt;
  &lt;text x="70" y="400"&gt;luminanceToAlpha&lt;/text&gt;
&lt;/svg&gt;</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", "100%", 700, "/files/4371/test.png")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Filters 1.0', '#feColorMatrixElement', '&lt;feColorMatrix&gt;')}}</td>
   <td>{{Spec2('Filters 1.0')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('SVG1.1', 'filters.html#feColorMatrixElement', '&lt;feColorMatrix&gt;')}}</td>
   <td>{{Spec2('SVG1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.feColorMatrix")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SVGElement("filter")}}</li>
 <li>{{SVGElement("animate")}}</li>
 <li>{{SVGElement("set")}}</li>
 <li>{{SVGElement("feBlend")}}</li>
 <li>{{SVGElement("feComponentTransfer")}}</li>
 <li>{{SVGElement("feComposite")}}</li>
 <li>{{SVGElement("feConvolveMatrix")}}</li>
 <li>{{SVGElement("feDiffuseLighting")}}</li>
 <li>{{SVGElement("feDisplacementMap")}}</li>
 <li>{{SVGElement("feFlood")}}</li>
 <li>{{SVGElement("feGaussianBlur")}}</li>
 <li>{{SVGElement("feImage")}}</li>
 <li>{{SVGElement("feMerge")}}</li>
 <li>{{SVGElement("feMorphology")}}</li>
 <li>{{SVGElement("feOffset")}}</li>
 <li>{{SVGElement("feSpecularLighting")}}</li>
 <li>{{SVGElement("feTile")}}</li>
 <li>{{SVGElement("feTurbulence")}}</li>
 <li><a href="/en-US/docs/Web/SVG/Tutorial/Filter_effects">SVG tutorial: Filter effects</a></li>
</ul>
